<a id="mypy-boto3-securityhub"></a>

# mypy-boto3-securityhub

[![PyPI - mypy-boto3-securityhub](https://img.shields.io/pypi/v/mypy-boto3-securityhub.svg?color=blue)](https://pypi.org/project/mypy-boto3-securityhub)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-securityhub.svg?color=blue)](https://pypi.org/project/mypy-boto3-securityhub)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_securityhub/)
[![PyPI - Downloads](https://static.pepy.tech/badge/mypy-boto3-securityhub)](https://pepy.tech/project/mypy-boto3-securityhub)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SecurityHub 1.28.15](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/securityhub.html#SecurityHub)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.16.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-securityhub docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_securityhub/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-securityhub](#mypy-boto3-securityhub)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SecurityHub`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `SecurityHub` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[securityhub]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[securityhub]'


# standalone installation
python -m pip install mypy-boto3-securityhub
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-securityhub
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[securityhub]` in your environment:

```bash
python -m pip install 'boto3-stubs[securityhub]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[securityhub]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[securityhub]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[securityhub]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[securityhub]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[securityhub]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[securityhub]` in your environment:

```bash
python -m pip install 'boto3-stubs[securityhub]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[securityhub]` in your environment:

```bash
python -m pip install 'boto3-stubs[securityhub]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SecurityHubClient` provides annotations for `boto3.client("securityhub")`.

```python
from boto3.session import Session

from mypy_boto3_securityhub import SecurityHubClient

client: SecurityHubClient = Session().client("securityhub")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_securityhub.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_securityhub import SecurityHubClient
from mypy_boto3_securityhub.paginator import (
    DescribeActionTargetsPaginator,
    DescribeProductsPaginator,
    DescribeStandardsPaginator,
    DescribeStandardsControlsPaginator,
    GetEnabledStandardsPaginator,
    GetFindingHistoryPaginator,
    GetFindingsPaginator,
    GetInsightsPaginator,
    ListEnabledProductsForImportPaginator,
    ListFindingAggregatorsPaginator,
    ListInvitationsPaginator,
    ListMembersPaginator,
    ListOrganizationAdminAccountsPaginator,
    ListSecurityControlDefinitionsPaginator,
    ListStandardsControlAssociationsPaginator,
)

client: SecurityHubClient = Session().client("securityhub")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
describe_action_targets_paginator: DescribeActionTargetsPaginator = client.get_paginator(
    "describe_action_targets"
)
describe_products_paginator: DescribeProductsPaginator = client.get_paginator("describe_products")
describe_standards_paginator: DescribeStandardsPaginator = client.get_paginator(
    "describe_standards"
)
describe_standards_controls_paginator: DescribeStandardsControlsPaginator = client.get_paginator(
    "describe_standards_controls"
)
get_enabled_standards_paginator: GetEnabledStandardsPaginator = client.get_paginator(
    "get_enabled_standards"
)
get_finding_history_paginator: GetFindingHistoryPaginator = client.get_paginator(
    "get_finding_history"
)
get_findings_paginator: GetFindingsPaginator = client.get_paginator("get_findings")
get_insights_paginator: GetInsightsPaginator = client.get_paginator("get_insights")
list_enabled_products_for_import_paginator: ListEnabledProductsForImportPaginator = (
    client.get_paginator("list_enabled_products_for_import")
)
list_finding_aggregators_paginator: ListFindingAggregatorsPaginator = client.get_paginator(
    "list_finding_aggregators"
)
list_invitations_paginator: ListInvitationsPaginator = client.get_paginator("list_invitations")
list_members_paginator: ListMembersPaginator = client.get_paginator("list_members")
list_organization_admin_accounts_paginator: ListOrganizationAdminAccountsPaginator = (
    client.get_paginator("list_organization_admin_accounts")
)
list_security_control_definitions_paginator: ListSecurityControlDefinitionsPaginator = (
    client.get_paginator("list_security_control_definitions")
)
list_standards_control_associations_paginator: ListStandardsControlAssociationsPaginator = (
    client.get_paginator("list_standards_control_associations")
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_securityhub.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_securityhub.literals import (
    AdminStatusType,
    AssociationStatusType,
    AutoEnableStandardsType,
    AutomationRulesActionTypeType,
    AwsIamAccessKeyStatusType,
    AwsS3BucketNotificationConfigurationS3KeyFilterRuleNameType,
    ComplianceStatusType,
    ControlFindingGeneratorType,
    ControlStatusType,
    DateRangeUnitType,
    DescribeActionTargetsPaginatorName,
    DescribeProductsPaginatorName,
    DescribeStandardsControlsPaginatorName,
    DescribeStandardsPaginatorName,
    FindingHistoryUpdateSourceTypeType,
    GetEnabledStandardsPaginatorName,
    GetFindingHistoryPaginatorName,
    GetFindingsPaginatorName,
    GetInsightsPaginatorName,
    IntegrationTypeType,
    ListEnabledProductsForImportPaginatorName,
    ListFindingAggregatorsPaginatorName,
    ListInvitationsPaginatorName,
    ListMembersPaginatorName,
    ListOrganizationAdminAccountsPaginatorName,
    ListSecurityControlDefinitionsPaginatorName,
    ListStandardsControlAssociationsPaginatorName,
    MalwareStateType,
    MalwareTypeType,
    MapFilterComparisonType,
    NetworkDirectionType,
    PartitionType,
    RecordStateType,
    RegionAvailabilityStatusType,
    RuleStatusType,
    SeverityLabelType,
    SeverityRatingType,
    SortOrderType,
    StandardsStatusType,
    StatusReasonCodeType,
    StringFilterComparisonType,
    ThreatIntelIndicatorCategoryType,
    ThreatIntelIndicatorTypeType,
    UnprocessedErrorCodeType,
    VerificationStateType,
    VulnerabilityFixAvailableType,
    WorkflowStateType,
    WorkflowStatusType,
    SecurityHubServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: AdminStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_securityhub.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_securityhub.type_defs import (
    AcceptAdministratorInvitationRequestRequestTypeDef,
    AcceptInvitationRequestRequestTypeDef,
    AccountDetailsTypeDef,
    ActionLocalIpDetailsTypeDef,
    ActionLocalPortDetailsTypeDef,
    DnsRequestActionTypeDef,
    CityTypeDef,
    CountryTypeDef,
    GeoLocationTypeDef,
    IpOrganizationDetailsTypeDef,
    ActionRemotePortDetailsTypeDef,
    ActionTargetTypeDef,
    AdjustmentTypeDef,
    AdminAccountTypeDef,
    AssociatedStandardTypeDef,
    AssociationStateDetailsTypeDef,
    NoteUpdateTypeDef,
    RelatedFindingTypeDef,
    SeverityUpdateTypeDef,
    WorkflowUpdateTypeDef,
    MapFilterTypeDef,
    NumberFilterTypeDef,
    StringFilterTypeDef,
    AutomationRulesMetadataTypeDef,
    AvailabilityZoneTypeDef,
    AwsAmazonMqBrokerEncryptionOptionsDetailsTypeDef,
    AwsAmazonMqBrokerLdapServerMetadataDetailsOutputTypeDef,
    AwsAmazonMqBrokerMaintenanceWindowStartTimeDetailsTypeDef,
    AwsAmazonMqBrokerUsersDetailsTypeDef,
    AwsAmazonMqBrokerLdapServerMetadataDetailsTypeDef,
    AwsAmazonMqBrokerLogsPendingDetailsTypeDef,
    AwsApiCallActionDomainDetailsTypeDef,
    AwsApiGatewayAccessLogSettingsTypeDef,
    AwsApiGatewayCanarySettingsOutputTypeDef,
    AwsApiGatewayCanarySettingsTypeDef,
    AwsApiGatewayEndpointConfigurationOutputTypeDef,
    AwsApiGatewayEndpointConfigurationTypeDef,
    AwsApiGatewayMethodSettingsTypeDef,
    AwsCorsConfigurationOutputTypeDef,
    AwsCorsConfigurationTypeDef,
    AwsApiGatewayV2RouteSettingsTypeDef,
    AwsAppSyncGraphQlApiLambdaAuthorizerConfigDetailsTypeDef,
    AwsAppSyncGraphQlApiOpenIdConnectConfigDetailsTypeDef,
    AwsAppSyncGraphQlApiUserPoolConfigDetailsTypeDef,
    AwsAppSyncGraphQlApiLogConfigDetailsTypeDef,
    AwsAthenaWorkGroupConfigurationResultConfigurationEncryptionConfigurationDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupAvailabilityZonesListDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupLaunchTemplateLaunchTemplateSpecificationTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyInstancesDistributionDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecificationTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyLaunchTemplateOverridesListDetailsTypeDef,
    AwsAutoScalingLaunchConfigurationBlockDeviceMappingsEbsDetailsTypeDef,
    AwsAutoScalingLaunchConfigurationInstanceMonitoringDetailsTypeDef,
    AwsAutoScalingLaunchConfigurationMetadataOptionsTypeDef,
    AwsBackupBackupPlanAdvancedBackupSettingsDetailsOutputTypeDef,
    AwsBackupBackupPlanAdvancedBackupSettingsDetailsTypeDef,
    AwsBackupBackupPlanLifecycleDetailsTypeDef,
    AwsBackupBackupVaultNotificationsDetailsOutputTypeDef,
    AwsBackupBackupVaultNotificationsDetailsTypeDef,
    AwsBackupRecoveryPointCalculatedLifecycleDetailsTypeDef,
    AwsBackupRecoveryPointCreatedByDetailsTypeDef,
    AwsBackupRecoveryPointLifecycleDetailsTypeDef,
    AwsCertificateManagerCertificateExtendedKeyUsageTypeDef,
    AwsCertificateManagerCertificateKeyUsageTypeDef,
    AwsCertificateManagerCertificateOptionsTypeDef,
    AwsCertificateManagerCertificateResourceRecordTypeDef,
    AwsCloudFormationStackDriftInformationDetailsTypeDef,
    AwsCloudFormationStackOutputsDetailsTypeDef,
    AwsCloudFrontDistributionCacheBehaviorTypeDef,
    AwsCloudFrontDistributionDefaultCacheBehaviorTypeDef,
    AwsCloudFrontDistributionLoggingTypeDef,
    AwsCloudFrontDistributionViewerCertificateTypeDef,
    AwsCloudFrontDistributionOriginSslProtocolsOutputTypeDef,
    AwsCloudFrontDistributionOriginSslProtocolsTypeDef,
    AwsCloudFrontDistributionOriginGroupFailoverStatusCodesOutputTypeDef,
    AwsCloudFrontDistributionOriginGroupFailoverStatusCodesTypeDef,
    AwsCloudFrontDistributionOriginS3OriginConfigTypeDef,
    AwsCloudTrailTrailDetailsTypeDef,
    AwsCloudWatchAlarmDimensionsDetailsTypeDef,
    AwsCodeBuildProjectArtifactsDetailsTypeDef,
    AwsCodeBuildProjectSourceTypeDef,
    AwsCodeBuildProjectVpcConfigOutputTypeDef,
    AwsCodeBuildProjectVpcConfigTypeDef,
    AwsCodeBuildProjectEnvironmentEnvironmentVariablesDetailsTypeDef,
    AwsCodeBuildProjectEnvironmentRegistryCredentialTypeDef,
    AwsCodeBuildProjectLogsConfigCloudWatchLogsDetailsTypeDef,
    AwsCodeBuildProjectLogsConfigS3LogsDetailsTypeDef,
    AwsDynamoDbTableAttributeDefinitionTypeDef,
    AwsDynamoDbTableBillingModeSummaryTypeDef,
    AwsDynamoDbTableKeySchemaTypeDef,
    AwsDynamoDbTableProvisionedThroughputTypeDef,
    AwsDynamoDbTableRestoreSummaryTypeDef,
    AwsDynamoDbTableSseDescriptionTypeDef,
    AwsDynamoDbTableStreamSpecificationTypeDef,
    AwsDynamoDbTableProjectionOutputTypeDef,
    AwsDynamoDbTableProjectionTypeDef,
    AwsDynamoDbTableProvisionedThroughputOverrideTypeDef,
    AwsEc2EipDetailsTypeDef,
    AwsEc2InstanceMetadataOptionsTypeDef,
    AwsEc2InstanceMonitoringDetailsTypeDef,
    AwsEc2InstanceNetworkInterfacesDetailsTypeDef,
    AwsEc2LaunchTemplateDataBlockDeviceMappingSetEbsDetailsTypeDef,
    AwsEc2LaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetDetailsTypeDef,
    AwsEc2LaunchTemplateDataCpuOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataCreditSpecificationDetailsTypeDef,
    AwsEc2LaunchTemplateDataElasticGpuSpecificationSetDetailsTypeDef,
    AwsEc2LaunchTemplateDataElasticInferenceAcceleratorSetDetailsTypeDef,
    AwsEc2LaunchTemplateDataEnclaveOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataHibernationOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataIamInstanceProfileDetailsTypeDef,
    AwsEc2LaunchTemplateDataLicenseSetDetailsTypeDef,
    AwsEc2LaunchTemplateDataMaintenanceOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataMetadataOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataMonitoringDetailsTypeDef,
    AwsEc2LaunchTemplateDataPlacementDetailsTypeDef,
    AwsEc2LaunchTemplateDataPrivateDnsNameOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceMarketOptionsSpotOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsAcceleratorCountDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsAcceleratorTotalMemoryMiBDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsBaselineEbsBandwidthMbpsDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsMemoryGiBPerVCpuDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsMemoryMiBDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsNetworkInterfaceCountDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsTotalLocalStorageGBDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsVCpuCountDetailsTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetIpv4PrefixesDetailsTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetIpv6AddressesDetailsTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetIpv6PrefixesDetailsTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetPrivateIpAddressesDetailsTypeDef,
    AwsEc2NetworkAclAssociationTypeDef,
    IcmpTypeCodeTypeDef,
    PortRangeFromToTypeDef,
    AwsEc2NetworkInterfaceAttachmentTypeDef,
    AwsEc2NetworkInterfaceIpV6AddressDetailTypeDef,
    AwsEc2NetworkInterfacePrivateIpAddressDetailTypeDef,
    AwsEc2NetworkInterfaceSecurityGroupTypeDef,
    PropagatingVgwSetDetailsTypeDef,
    RouteSetDetailsTypeDef,
    AwsEc2SecurityGroupIpRangeTypeDef,
    AwsEc2SecurityGroupIpv6RangeTypeDef,
    AwsEc2SecurityGroupPrefixListIdTypeDef,
    AwsEc2SecurityGroupUserIdGroupPairTypeDef,
    Ipv6CidrBlockAssociationTypeDef,
    AwsEc2TransitGatewayDetailsOutputTypeDef,
    AwsEc2TransitGatewayDetailsTypeDef,
    AwsEc2VolumeAttachmentTypeDef,
    CidrBlockAssociationTypeDef,
    AwsEc2VpcEndpointServiceServiceTypeDetailsTypeDef,
    AwsEc2VpcPeeringConnectionStatusDetailsTypeDef,
    VpcInfoCidrBlockSetDetailsTypeDef,
    VpcInfoIpv6CidrBlockSetDetailsTypeDef,
    VpcInfoPeeringOptionsDetailsTypeDef,
    AwsEc2VpnConnectionRoutesDetailsTypeDef,
    AwsEc2VpnConnectionVgwTelemetryDetailsTypeDef,
    AwsEc2VpnConnectionOptionsTunnelOptionsDetailsOutputTypeDef,
    AwsEc2VpnConnectionOptionsTunnelOptionsDetailsTypeDef,
    AwsEcrContainerImageDetailsOutputTypeDef,
    AwsEcrContainerImageDetailsTypeDef,
    AwsEcrRepositoryImageScanningConfigurationDetailsTypeDef,
    AwsEcrRepositoryLifecyclePolicyDetailsTypeDef,
    AwsEcsClusterClusterSettingsDetailsTypeDef,
    AwsEcsClusterConfigurationExecuteCommandConfigurationLogConfigurationDetailsTypeDef,
    AwsEcsClusterDefaultCapacityProviderStrategyDetailsTypeDef,
    AwsMountPointTypeDef,
    AwsEcsServiceCapacityProviderStrategyDetailsTypeDef,
    AwsEcsServiceDeploymentConfigurationDeploymentCircuitBreakerDetailsTypeDef,
    AwsEcsServiceDeploymentControllerDetailsTypeDef,
    AwsEcsServiceLoadBalancersDetailsTypeDef,
    AwsEcsServicePlacementConstraintsDetailsTypeDef,
    AwsEcsServicePlacementStrategiesDetailsTypeDef,
    AwsEcsServiceServiceRegistriesDetailsTypeDef,
    AwsEcsServiceNetworkConfigurationAwsVpcConfigurationDetailsOutputTypeDef,
    AwsEcsServiceNetworkConfigurationAwsVpcConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsDependsOnDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsEnvironmentDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsEnvironmentFilesDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsExtraHostsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsFirelensConfigurationDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsHealthCheckDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsMountPointsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsPortMappingsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsRepositoryCredentialsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsResourceRequirementsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsSecretsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsSystemControlsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsUlimitsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsVolumesFromDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsFirelensConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsHealthCheckDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersCapabilitiesDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersCapabilitiesDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersDevicesDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersTmpfsDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersDevicesDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersTmpfsDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLogConfigurationSecretOptionsDetailsTypeDef,
    AwsEcsTaskDefinitionInferenceAcceleratorsDetailsTypeDef,
    AwsEcsTaskDefinitionPlacementConstraintsDetailsTypeDef,
    AwsEcsTaskDefinitionProxyConfigurationProxyConfigurationPropertiesDetailsTypeDef,
    AwsEcsTaskDefinitionVolumesDockerVolumeConfigurationDetailsOutputTypeDef,
    AwsEcsTaskDefinitionVolumesHostDetailsTypeDef,
    AwsEcsTaskDefinitionVolumesDockerVolumeConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionVolumesEfsVolumeConfigurationAuthorizationConfigDetailsTypeDef,
    AwsEcsTaskVolumeHostDetailsTypeDef,
    AwsEfsAccessPointPosixUserDetailsOutputTypeDef,
    AwsEfsAccessPointPosixUserDetailsTypeDef,
    AwsEfsAccessPointRootDirectoryCreationInfoDetailsTypeDef,
    AwsEksClusterResourcesVpcConfigDetailsOutputTypeDef,
    AwsEksClusterResourcesVpcConfigDetailsTypeDef,
    AwsEksClusterLoggingClusterLoggingDetailsOutputTypeDef,
    AwsEksClusterLoggingClusterLoggingDetailsTypeDef,
    AwsElasticBeanstalkEnvironmentEnvironmentLinkTypeDef,
    AwsElasticBeanstalkEnvironmentOptionSettingTypeDef,
    AwsElasticBeanstalkEnvironmentTierTypeDef,
    AwsElasticsearchDomainDomainEndpointOptionsTypeDef,
    AwsElasticsearchDomainEncryptionAtRestOptionsTypeDef,
    AwsElasticsearchDomainNodeToNodeEncryptionOptionsTypeDef,
    AwsElasticsearchDomainServiceSoftwareOptionsTypeDef,
    AwsElasticsearchDomainVPCOptionsOutputTypeDef,
    AwsElasticsearchDomainVPCOptionsTypeDef,
    AwsElasticsearchDomainElasticsearchClusterConfigZoneAwarenessConfigDetailsTypeDef,
    AwsElasticsearchDomainLogPublishingOptionsLogConfigTypeDef,
    AwsElbAppCookieStickinessPolicyTypeDef,
    AwsElbLbCookieStickinessPolicyTypeDef,
    AwsElbLoadBalancerAccessLogTypeDef,
    AwsElbLoadBalancerAdditionalAttributeTypeDef,
    AwsElbLoadBalancerConnectionDrainingTypeDef,
    AwsElbLoadBalancerConnectionSettingsTypeDef,
    AwsElbLoadBalancerCrossZoneLoadBalancingTypeDef,
    AwsElbLoadBalancerBackendServerDescriptionOutputTypeDef,
    AwsElbLoadBalancerBackendServerDescriptionTypeDef,
    AwsElbLoadBalancerHealthCheckTypeDef,
    AwsElbLoadBalancerInstanceTypeDef,
    AwsElbLoadBalancerSourceSecurityGroupTypeDef,
    AwsElbLoadBalancerListenerTypeDef,
    AwsElbv2LoadBalancerAttributeTypeDef,
    LoadBalancerStateTypeDef,
    AwsEventSchemasRegistryDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesCloudTrailDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesDnsLogsDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesFlowLogsDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesS3LogsDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesKubernetesAuditLogsDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesMalwareProtectionScanEc2InstanceWithFindingsEbsVolumesDetailsTypeDef,
    AwsGuardDutyDetectorFeaturesDetailsTypeDef,
    AwsIamAccessKeySessionContextAttributesTypeDef,
    AwsIamAccessKeySessionContextSessionIssuerTypeDef,
    AwsIamAttachedManagedPolicyTypeDef,
    AwsIamGroupPolicyTypeDef,
    AwsIamInstanceProfileRoleTypeDef,
    AwsIamPermissionsBoundaryTypeDef,
    AwsIamPolicyVersionTypeDef,
    AwsIamRolePolicyTypeDef,
    AwsIamUserPolicyTypeDef,
    AwsKinesisStreamStreamEncryptionDetailsTypeDef,
    AwsKmsKeyDetailsTypeDef,
    AwsLambdaFunctionCodeTypeDef,
    AwsLambdaFunctionDeadLetterConfigTypeDef,
    AwsLambdaFunctionLayerTypeDef,
    AwsLambdaFunctionTracingConfigTypeDef,
    AwsLambdaFunctionVpcConfigOutputTypeDef,
    AwsLambdaFunctionVpcConfigTypeDef,
    AwsLambdaFunctionEnvironmentErrorTypeDef,
    AwsLambdaLayerVersionDetailsOutputTypeDef,
    AwsLambdaLayerVersionDetailsTypeDef,
    AwsNetworkFirewallFirewallSubnetMappingsDetailsTypeDef,
    AwsOpenSearchServiceDomainMasterUserOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainClusterConfigZoneAwarenessConfigDetailsTypeDef,
    AwsOpenSearchServiceDomainDomainEndpointOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainEncryptionAtRestOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainNodeToNodeEncryptionOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainServiceSoftwareOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainVpcOptionsDetailsOutputTypeDef,
    AwsOpenSearchServiceDomainVpcOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainLogPublishingOptionTypeDef,
    AwsRdsDbClusterAssociatedRoleTypeDef,
    AwsRdsDbClusterMemberTypeDef,
    AwsRdsDbClusterOptionGroupMembershipTypeDef,
    AwsRdsDbDomainMembershipTypeDef,
    AwsRdsDbInstanceVpcSecurityGroupTypeDef,
    AwsRdsDbClusterSnapshotDbClusterSnapshotAttributeOutputTypeDef,
    AwsRdsDbClusterSnapshotDbClusterSnapshotAttributeTypeDef,
    AwsRdsDbInstanceAssociatedRoleTypeDef,
    AwsRdsDbInstanceEndpointTypeDef,
    AwsRdsDbOptionGroupMembershipTypeDef,
    AwsRdsDbParameterGroupTypeDef,
    AwsRdsDbProcessorFeatureTypeDef,
    AwsRdsDbStatusInfoTypeDef,
    AwsRdsPendingCloudWatchLogsExportsOutputTypeDef,
    AwsRdsPendingCloudWatchLogsExportsTypeDef,
    AwsRdsDbSecurityGroupEc2SecurityGroupTypeDef,
    AwsRdsDbSecurityGroupIpRangeTypeDef,
    AwsRdsDbSubnetGroupSubnetAvailabilityZoneTypeDef,
    AwsRdsEventSubscriptionDetailsOutputTypeDef,
    AwsRdsEventSubscriptionDetailsTypeDef,
    AwsRedshiftClusterClusterNodeTypeDef,
    AwsRedshiftClusterClusterParameterStatusTypeDef,
    AwsRedshiftClusterClusterSecurityGroupTypeDef,
    AwsRedshiftClusterClusterSnapshotCopyStatusTypeDef,
    AwsRedshiftClusterDeferredMaintenanceWindowTypeDef,
    AwsRedshiftClusterElasticIpStatusTypeDef,
    AwsRedshiftClusterEndpointTypeDef,
    AwsRedshiftClusterHsmStatusTypeDef,
    AwsRedshiftClusterIamRoleTypeDef,
    AwsRedshiftClusterLoggingStatusTypeDef,
    AwsRedshiftClusterPendingModifiedValuesTypeDef,
    AwsRedshiftClusterResizeInfoTypeDef,
    AwsRedshiftClusterRestoreStatusTypeDef,
    AwsRedshiftClusterVpcSecurityGroupTypeDef,
    AwsS3AccountPublicAccessBlockDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesAbortIncompleteMultipartUploadDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesNoncurrentVersionTransitionsDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesTransitionsDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterPredicateTagDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterPredicateOperandsTagDetailsTypeDef,
    AwsS3BucketBucketVersioningConfigurationTypeDef,
    AwsS3BucketLoggingConfigurationTypeDef,
    AwsS3BucketNotificationConfigurationS3KeyFilterRuleTypeDef,
    AwsS3BucketObjectLockConfigurationRuleDefaultRetentionDetailsTypeDef,
    AwsS3BucketServerSideEncryptionByDefaultTypeDef,
    AwsS3BucketWebsiteConfigurationRedirectToTypeDef,
    AwsS3BucketWebsiteConfigurationRoutingRuleConditionTypeDef,
    AwsS3BucketWebsiteConfigurationRoutingRuleRedirectTypeDef,
    AwsS3ObjectDetailsTypeDef,
    AwsSageMakerNotebookInstanceMetadataServiceConfigurationDetailsTypeDef,
    AwsSecretsManagerSecretRotationRulesTypeDef,
    BooleanFilterTypeDef,
    IpFilterTypeDef,
    KeywordFilterTypeDef,
    AwsSecurityFindingIdentifierTypeDef,
    MalwareTypeDef,
    NoteTypeDef,
    PatchSummaryTypeDef,
    ProcessDetailsTypeDef,
    SeverityTypeDef,
    ThreatIntelIndicatorTypeDef,
    WorkflowTypeDef,
    AwsSnsTopicSubscriptionTypeDef,
    AwsSqsQueueDetailsTypeDef,
    AwsSsmComplianceSummaryTypeDef,
    AwsStepFunctionStateMachineTracingConfigurationDetailsTypeDef,
    AwsStepFunctionStateMachineLoggingConfigurationDestinationsCloudWatchLogsLogGroupDetailsTypeDef,
    AwsWafRateBasedRuleMatchPredicateTypeDef,
    AwsWafRegionalRateBasedRuleMatchPredicateTypeDef,
    AwsWafRegionalRulePredicateListDetailsTypeDef,
    AwsWafRegionalRuleGroupRulesActionDetailsTypeDef,
    AwsWafRegionalWebAclRulesListActionDetailsTypeDef,
    AwsWafRegionalWebAclRulesListOverrideActionDetailsTypeDef,
    AwsWafRulePredicateListDetailsTypeDef,
    AwsWafRuleGroupRulesActionDetailsTypeDef,
    WafActionTypeDef,
    WafExcludedRuleTypeDef,
    WafOverrideActionTypeDef,
    AwsWafv2CustomHttpHeaderTypeDef,
    AwsWafv2VisibilityConfigDetailsTypeDef,
    AwsWafv2WebAclCaptchaConfigImmunityTimePropertyDetailsTypeDef,
    AwsXrayEncryptionConfigDetailsTypeDef,
    BatchDeleteAutomationRulesRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    UnprocessedAutomationRuleTypeDef,
    BatchDisableStandardsRequestRequestTypeDef,
    StandardsSubscriptionRequestTypeDef,
    BatchGetAutomationRulesRequestRequestTypeDef,
    BatchGetSecurityControlsRequestRequestTypeDef,
    SecurityControlTypeDef,
    UnprocessedSecurityControlTypeDef,
    StandardsControlAssociationIdTypeDef,
    StandardsControlAssociationDetailTypeDef,
    ImportFindingsErrorTypeDef,
    StandardsControlAssociationUpdateTypeDef,
    CellTypeDef,
    ClassificationStatusTypeDef,
    StatusReasonTypeDef,
    VolumeMountTypeDef,
    CreateActionTargetRequestRequestTypeDef,
    CreateFindingAggregatorRequestRequestTypeDef,
    ResultTypeDef,
    DateRangeTypeDef,
    DeclineInvitationsRequestRequestTypeDef,
    DeleteActionTargetRequestRequestTypeDef,
    DeleteFindingAggregatorRequestRequestTypeDef,
    DeleteInsightRequestRequestTypeDef,
    DeleteInvitationsRequestRequestTypeDef,
    DeleteMembersRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    DescribeActionTargetsRequestRequestTypeDef,
    DescribeHubRequestRequestTypeDef,
    DescribeProductsRequestRequestTypeDef,
    ProductTypeDef,
    DescribeStandardsControlsRequestRequestTypeDef,
    StandardsControlTypeDef,
    DescribeStandardsRequestRequestTypeDef,
    DisableImportFindingsForProductRequestRequestTypeDef,
    DisableOrganizationAdminAccountRequestRequestTypeDef,
    DisassociateMembersRequestRequestTypeDef,
    EnableImportFindingsForProductRequestRequestTypeDef,
    EnableOrganizationAdminAccountRequestRequestTypeDef,
    EnableSecurityHubRequestRequestTypeDef,
    FilePathsTypeDef,
    FindingAggregatorTypeDef,
    FindingHistoryUpdateSourceTypeDef,
    FindingHistoryUpdateTypeDef,
    FindingProviderSeverityTypeDef,
    FirewallPolicyStatefulRuleGroupReferencesDetailsTypeDef,
    FirewallPolicyStatelessRuleGroupReferencesDetailsTypeDef,
    InvitationTypeDef,
    GetEnabledStandardsRequestRequestTypeDef,
    GetFindingAggregatorRequestRequestTypeDef,
    SortCriterionTypeDef,
    GetInsightResultsRequestRequestTypeDef,
    GetInsightsRequestRequestTypeDef,
    GetMembersRequestRequestTypeDef,
    MemberTypeDef,
    InsightResultValueTypeDef,
    InviteMembersRequestRequestTypeDef,
    ListAutomationRulesRequestRequestTypeDef,
    ListEnabledProductsForImportRequestRequestTypeDef,
    ListFindingAggregatorsRequestRequestTypeDef,
    ListInvitationsRequestRequestTypeDef,
    ListMembersRequestRequestTypeDef,
    ListOrganizationAdminAccountsRequestRequestTypeDef,
    ListSecurityControlDefinitionsRequestRequestTypeDef,
    SecurityControlDefinitionTypeDef,
    ListStandardsControlAssociationsRequestRequestTypeDef,
    StandardsControlAssociationSummaryTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    PortRangeTypeDef,
    RangeTypeDef,
    RecordTypeDef,
    RecommendationTypeDef,
    RuleGroupSourceListDetailsOutputTypeDef,
    RuleGroupSourceListDetailsTypeDef,
    RuleGroupSourceStatefulRulesHeaderDetailsTypeDef,
    RuleGroupSourceStatefulRulesOptionsDetailsOutputTypeDef,
    RuleGroupSourceStatefulRulesOptionsDetailsTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesDestinationPortsTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesDestinationsTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesSourcePortsTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesSourcesTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesTcpFlagsOutputTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesTcpFlagsTypeDef,
    RuleGroupVariablesIpSetsDetailsOutputTypeDef,
    RuleGroupVariablesIpSetsDetailsTypeDef,
    RuleGroupVariablesPortSetsDetailsOutputTypeDef,
    RuleGroupVariablesPortSetsDetailsTypeDef,
    SoftwarePackageTypeDef,
    StandardsManagedByTypeDef,
    StandardsStatusReasonTypeDef,
    StatelessCustomPublishMetricActionDimensionTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateActionTargetRequestRequestTypeDef,
    UpdateFindingAggregatorRequestRequestTypeDef,
    UpdateOrganizationConfigurationRequestRequestTypeDef,
    UpdateSecurityHubConfigurationRequestRequestTypeDef,
    UpdateStandardsControlRequestRequestTypeDef,
    VulnerabilityVendorTypeDef,
    CreateMembersRequestRequestTypeDef,
    ActionRemoteIpDetailsTypeDef,
    CvssOutputTypeDef,
    CvssTypeDef,
    AssociationSetDetailsTypeDef,
    AutomationRulesFindingFieldsUpdateOutputTypeDef,
    AutomationRulesFindingFieldsUpdateTypeDef,
    AwsAmazonMqBrokerLogsDetailsTypeDef,
    AwsApiGatewayRestApiDetailsOutputTypeDef,
    AwsApiGatewayRestApiDetailsTypeDef,
    AwsApiGatewayStageDetailsOutputTypeDef,
    AwsApiGatewayStageDetailsTypeDef,
    AwsApiGatewayV2ApiDetailsOutputTypeDef,
    AwsApiGatewayV2ApiDetailsTypeDef,
    AwsApiGatewayV2StageDetailsOutputTypeDef,
    AwsApiGatewayV2StageDetailsTypeDef,
    AwsAppSyncGraphQlApiAdditionalAuthenticationProvidersDetailsTypeDef,
    AwsAthenaWorkGroupConfigurationResultConfigurationDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyLaunchTemplateDetailsOutputTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyLaunchTemplateDetailsTypeDef,
    AwsAutoScalingLaunchConfigurationBlockDeviceMappingsDetailsTypeDef,
    AwsBackupBackupPlanRuleCopyActionsDetailsTypeDef,
    AwsBackupBackupVaultDetailsOutputTypeDef,
    AwsBackupBackupVaultDetailsTypeDef,
    AwsBackupRecoveryPointDetailsTypeDef,
    AwsCertificateManagerCertificateDomainValidationOptionOutputTypeDef,
    AwsCertificateManagerCertificateDomainValidationOptionTypeDef,
    AwsCloudFormationStackDetailsOutputTypeDef,
    AwsCloudFormationStackDetailsTypeDef,
    AwsCloudFrontDistributionCacheBehaviorsOutputTypeDef,
    AwsCloudFrontDistributionCacheBehaviorsTypeDef,
    AwsCloudFrontDistributionOriginCustomOriginConfigOutputTypeDef,
    AwsCloudFrontDistributionOriginCustomOriginConfigTypeDef,
    AwsCloudFrontDistributionOriginGroupFailoverOutputTypeDef,
    AwsCloudFrontDistributionOriginGroupFailoverTypeDef,
    AwsCloudWatchAlarmDetailsOutputTypeDef,
    AwsCloudWatchAlarmDetailsTypeDef,
    AwsCodeBuildProjectEnvironmentOutputTypeDef,
    AwsCodeBuildProjectEnvironmentTypeDef,
    AwsCodeBuildProjectLogsConfigDetailsTypeDef,
    AwsDynamoDbTableGlobalSecondaryIndexOutputTypeDef,
    AwsDynamoDbTableLocalSecondaryIndexOutputTypeDef,
    AwsDynamoDbTableGlobalSecondaryIndexTypeDef,
    AwsDynamoDbTableLocalSecondaryIndexTypeDef,
    AwsDynamoDbTableReplicaGlobalSecondaryIndexTypeDef,
    AwsEc2InstanceDetailsOutputTypeDef,
    AwsEc2InstanceDetailsTypeDef,
    AwsEc2LaunchTemplateDataBlockDeviceMappingSetDetailsTypeDef,
    AwsEc2LaunchTemplateDataCapacityReservationSpecificationDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceMarketOptionsDetailsTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsDetailsOutputTypeDef,
    AwsEc2LaunchTemplateDataInstanceRequirementsDetailsTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetDetailsOutputTypeDef,
    AwsEc2LaunchTemplateDataNetworkInterfaceSetDetailsTypeDef,
    AwsEc2NetworkAclEntryTypeDef,
    AwsEc2NetworkInterfaceDetailsOutputTypeDef,
    AwsEc2NetworkInterfaceDetailsTypeDef,
    AwsEc2SecurityGroupIpPermissionOutputTypeDef,
    AwsEc2SecurityGroupIpPermissionTypeDef,
    AwsEc2SubnetDetailsOutputTypeDef,
    AwsEc2SubnetDetailsTypeDef,
    AwsEc2VolumeDetailsOutputTypeDef,
    AwsEc2VolumeDetailsTypeDef,
    AwsEc2VpcDetailsOutputTypeDef,
    AwsEc2VpcDetailsTypeDef,
    AwsEc2VpcEndpointServiceDetailsOutputTypeDef,
    AwsEc2VpcEndpointServiceDetailsTypeDef,
    AwsEc2VpcPeeringConnectionVpcInfoDetailsOutputTypeDef,
    AwsEc2VpcPeeringConnectionVpcInfoDetailsTypeDef,
    AwsEc2VpnConnectionOptionsDetailsOutputTypeDef,
    AwsEc2VpnConnectionOptionsDetailsTypeDef,
    AwsEcrRepositoryDetailsTypeDef,
    AwsEcsClusterConfigurationExecuteCommandConfigurationDetailsTypeDef,
    AwsEcsContainerDetailsOutputTypeDef,
    AwsEcsContainerDetailsTypeDef,
    AwsEcsServiceDeploymentConfigurationDetailsTypeDef,
    AwsEcsServiceNetworkConfigurationDetailsOutputTypeDef,
    AwsEcsServiceNetworkConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLinuxParametersDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLogConfigurationDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsLogConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionProxyConfigurationDetailsOutputTypeDef,
    AwsEcsTaskDefinitionProxyConfigurationDetailsTypeDef,
    AwsEcsTaskDefinitionVolumesEfsVolumeConfigurationDetailsTypeDef,
    AwsEcsTaskVolumeDetailsTypeDef,
    AwsEfsAccessPointRootDirectoryDetailsTypeDef,
    AwsEksClusterLoggingDetailsOutputTypeDef,
    AwsEksClusterLoggingDetailsTypeDef,
    AwsElasticBeanstalkEnvironmentDetailsOutputTypeDef,
    AwsElasticBeanstalkEnvironmentDetailsTypeDef,
    AwsElasticsearchDomainElasticsearchClusterConfigDetailsTypeDef,
    AwsElasticsearchDomainLogPublishingOptionsTypeDef,
    AwsElbLoadBalancerPoliciesOutputTypeDef,
    AwsElbLoadBalancerPoliciesTypeDef,
    AwsElbLoadBalancerAttributesOutputTypeDef,
    AwsElbLoadBalancerAttributesTypeDef,
    AwsElbLoadBalancerListenerDescriptionOutputTypeDef,
    AwsElbLoadBalancerListenerDescriptionTypeDef,
    AwsElbv2LoadBalancerDetailsOutputTypeDef,
    AwsElbv2LoadBalancerDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesKubernetesDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesMalwareProtectionScanEc2InstanceWithFindingsDetailsTypeDef,
    AwsIamAccessKeySessionContextTypeDef,
    AwsIamGroupDetailsOutputTypeDef,
    AwsIamGroupDetailsTypeDef,
    AwsIamInstanceProfileOutputTypeDef,
    AwsIamInstanceProfileTypeDef,
    AwsIamPolicyDetailsOutputTypeDef,
    AwsIamPolicyDetailsTypeDef,
    AwsIamUserDetailsOutputTypeDef,
    AwsIamUserDetailsTypeDef,
    AwsKinesisStreamDetailsTypeDef,
    AwsLambdaFunctionEnvironmentOutputTypeDef,
    AwsLambdaFunctionEnvironmentTypeDef,
    AwsNetworkFirewallFirewallDetailsOutputTypeDef,
    AwsNetworkFirewallFirewallDetailsTypeDef,
    AwsOpenSearchServiceDomainAdvancedSecurityOptionsDetailsTypeDef,
    AwsOpenSearchServiceDomainClusterConfigDetailsTypeDef,
    AwsOpenSearchServiceDomainLogPublishingOptionsDetailsTypeDef,
    AwsRdsDbClusterDetailsOutputTypeDef,
    AwsRdsDbClusterDetailsTypeDef,
    AwsRdsDbClusterSnapshotDetailsOutputTypeDef,
    AwsRdsDbClusterSnapshotDetailsTypeDef,
    AwsRdsDbSnapshotDetailsOutputTypeDef,
    AwsRdsDbSnapshotDetailsTypeDef,
    AwsRdsDbPendingModifiedValuesOutputTypeDef,
    AwsRdsDbPendingModifiedValuesTypeDef,
    AwsRdsDbSecurityGroupDetailsOutputTypeDef,
    AwsRdsDbSecurityGroupDetailsTypeDef,
    AwsRdsDbSubnetGroupSubnetTypeDef,
    AwsRedshiftClusterClusterParameterGroupOutputTypeDef,
    AwsRedshiftClusterClusterParameterGroupTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterPredicateOperandsDetailsTypeDef,
    AwsS3BucketNotificationConfigurationS3KeyFilterOutputTypeDef,
    AwsS3BucketNotificationConfigurationS3KeyFilterTypeDef,
    AwsS3BucketObjectLockConfigurationRuleDetailsTypeDef,
    AwsS3BucketServerSideEncryptionRuleTypeDef,
    AwsS3BucketWebsiteConfigurationRoutingRuleTypeDef,
    AwsSageMakerNotebookInstanceDetailsOutputTypeDef,
    AwsSageMakerNotebookInstanceDetailsTypeDef,
    AwsSecretsManagerSecretDetailsTypeDef,
    BatchUpdateFindingsRequestRequestTypeDef,
    BatchUpdateFindingsUnprocessedFindingTypeDef,
    GetFindingHistoryRequestRequestTypeDef,
    AwsSnsTopicDetailsOutputTypeDef,
    AwsSnsTopicDetailsTypeDef,
    AwsSsmPatchTypeDef,
    AwsStepFunctionStateMachineLoggingConfigurationDestinationsDetailsTypeDef,
    AwsWafRateBasedRuleDetailsOutputTypeDef,
    AwsWafRateBasedRuleDetailsTypeDef,
    AwsWafRegionalRateBasedRuleDetailsOutputTypeDef,
    AwsWafRegionalRateBasedRuleDetailsTypeDef,
    AwsWafRegionalRuleDetailsOutputTypeDef,
    AwsWafRegionalRuleDetailsTypeDef,
    AwsWafRegionalRuleGroupRulesDetailsTypeDef,
    AwsWafRegionalWebAclRulesListDetailsTypeDef,
    AwsWafRuleDetailsOutputTypeDef,
    AwsWafRuleDetailsTypeDef,
    AwsWafRuleGroupRulesDetailsTypeDef,
    AwsWafWebAclRuleOutputTypeDef,
    AwsWafWebAclRuleTypeDef,
    AwsWafv2CustomRequestHandlingDetailsOutputTypeDef,
    AwsWafv2CustomRequestHandlingDetailsTypeDef,
    AwsWafv2CustomResponseDetailsOutputTypeDef,
    AwsWafv2CustomResponseDetailsTypeDef,
    AwsWafv2WebAclCaptchaConfigDetailsTypeDef,
    CreateActionTargetResponseTypeDef,
    CreateAutomationRuleResponseTypeDef,
    CreateFindingAggregatorResponseTypeDef,
    CreateInsightResponseTypeDef,
    DeleteActionTargetResponseTypeDef,
    DeleteInsightResponseTypeDef,
    DescribeActionTargetsResponseTypeDef,
    DescribeHubResponseTypeDef,
    DescribeOrganizationConfigurationResponseTypeDef,
    EnableImportFindingsForProductResponseTypeDef,
    GetFindingAggregatorResponseTypeDef,
    GetInvitationsCountResponseTypeDef,
    ListAutomationRulesResponseTypeDef,
    ListEnabledProductsForImportResponseTypeDef,
    ListOrganizationAdminAccountsResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    UpdateFindingAggregatorResponseTypeDef,
    BatchDeleteAutomationRulesResponseTypeDef,
    BatchUpdateAutomationRulesResponseTypeDef,
    BatchEnableStandardsRequestRequestTypeDef,
    BatchGetSecurityControlsResponseTypeDef,
    BatchGetStandardsControlAssociationsRequestRequestTypeDef,
    UnprocessedStandardsControlAssociationTypeDef,
    BatchImportFindingsResponseTypeDef,
    BatchUpdateStandardsControlAssociationsRequestRequestTypeDef,
    UnprocessedStandardsControlAssociationUpdateTypeDef,
    ComplianceOutputTypeDef,
    ComplianceTypeDef,
    ContainerDetailsOutputTypeDef,
    ContainerDetailsTypeDef,
    CreateMembersResponseTypeDef,
    DeclineInvitationsResponseTypeDef,
    DeleteInvitationsResponseTypeDef,
    DeleteMembersResponseTypeDef,
    InviteMembersResponseTypeDef,
    DateFilterTypeDef,
    DescribeActionTargetsRequestDescribeActionTargetsPaginateTypeDef,
    DescribeProductsRequestDescribeProductsPaginateTypeDef,
    DescribeStandardsControlsRequestDescribeStandardsControlsPaginateTypeDef,
    DescribeStandardsRequestDescribeStandardsPaginateTypeDef,
    GetEnabledStandardsRequestGetEnabledStandardsPaginateTypeDef,
    GetFindingHistoryRequestGetFindingHistoryPaginateTypeDef,
    GetInsightsRequestGetInsightsPaginateTypeDef,
    ListEnabledProductsForImportRequestListEnabledProductsForImportPaginateTypeDef,
    ListFindingAggregatorsRequestListFindingAggregatorsPaginateTypeDef,
    ListInvitationsRequestListInvitationsPaginateTypeDef,
    ListMembersRequestListMembersPaginateTypeDef,
    ListOrganizationAdminAccountsRequestListOrganizationAdminAccountsPaginateTypeDef,
    ListSecurityControlDefinitionsRequestListSecurityControlDefinitionsPaginateTypeDef,
    ListStandardsControlAssociationsRequestListStandardsControlAssociationsPaginateTypeDef,
    DescribeProductsResponseTypeDef,
    DescribeStandardsControlsResponseTypeDef,
    ThreatOutputTypeDef,
    ThreatTypeDef,
    ListFindingAggregatorsResponseTypeDef,
    FindingHistoryRecordTypeDef,
    FindingProviderFieldsOutputTypeDef,
    FindingProviderFieldsTypeDef,
    GetAdministratorAccountResponseTypeDef,
    GetMasterAccountResponseTypeDef,
    ListInvitationsResponseTypeDef,
    GetMembersResponseTypeDef,
    ListMembersResponseTypeDef,
    InsightResultsTypeDef,
    ListSecurityControlDefinitionsResponseTypeDef,
    ListStandardsControlAssociationsResponseTypeDef,
    NetworkPathComponentDetailsOutputTypeDef,
    NetworkPathComponentDetailsTypeDef,
    NetworkTypeDef,
    PageTypeDef,
    RemediationTypeDef,
    RuleGroupSourceStatefulRulesDetailsOutputTypeDef,
    RuleGroupSourceStatefulRulesDetailsTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesOutputTypeDef,
    RuleGroupSourceStatelessRuleMatchAttributesTypeDef,
    RuleGroupVariablesOutputTypeDef,
    RuleGroupVariablesTypeDef,
    StandardTypeDef,
    StandardsSubscriptionTypeDef,
    StatelessCustomPublishMetricActionOutputTypeDef,
    StatelessCustomPublishMetricActionTypeDef,
    AwsApiCallActionOutputTypeDef,
    AwsApiCallActionTypeDef,
    NetworkConnectionActionTypeDef,
    PortProbeDetailTypeDef,
    VulnerabilityOutputTypeDef,
    VulnerabilityTypeDef,
    AwsEc2RouteTableDetailsOutputTypeDef,
    AwsEc2RouteTableDetailsTypeDef,
    AutomationRulesActionOutputTypeDef,
    AutomationRulesActionTypeDef,
    AwsAmazonMqBrokerDetailsOutputTypeDef,
    AwsAmazonMqBrokerDetailsTypeDef,
    AwsAppSyncGraphQlApiDetailsOutputTypeDef,
    AwsAppSyncGraphQlApiDetailsTypeDef,
    AwsAthenaWorkGroupConfigurationDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyDetailsOutputTypeDef,
    AwsAutoScalingAutoScalingGroupMixedInstancesPolicyDetailsTypeDef,
    AwsAutoScalingLaunchConfigurationDetailsOutputTypeDef,
    AwsAutoScalingLaunchConfigurationDetailsTypeDef,
    AwsBackupBackupPlanRuleDetailsOutputTypeDef,
    AwsBackupBackupPlanRuleDetailsTypeDef,
    AwsCertificateManagerCertificateRenewalSummaryOutputTypeDef,
    AwsCertificateManagerCertificateRenewalSummaryTypeDef,
    AwsCloudFrontDistributionOriginItemOutputTypeDef,
    AwsCloudFrontDistributionOriginItemTypeDef,
    AwsCloudFrontDistributionOriginGroupOutputTypeDef,
    AwsCloudFrontDistributionOriginGroupTypeDef,
    AwsCodeBuildProjectDetailsOutputTypeDef,
    AwsCodeBuildProjectDetailsTypeDef,
    AwsDynamoDbTableReplicaOutputTypeDef,
    AwsDynamoDbTableReplicaTypeDef,
    AwsEc2LaunchTemplateDataDetailsOutputTypeDef,
    AwsEc2LaunchTemplateDataDetailsTypeDef,
    AwsEc2NetworkAclDetailsOutputTypeDef,
    AwsEc2NetworkAclDetailsTypeDef,
    AwsEc2SecurityGroupDetailsOutputTypeDef,
    AwsEc2SecurityGroupDetailsTypeDef,
    AwsEc2VpcPeeringConnectionDetailsOutputTypeDef,
    AwsEc2VpcPeeringConnectionDetailsTypeDef,
    AwsEc2VpnConnectionDetailsOutputTypeDef,
    AwsEc2VpnConnectionDetailsTypeDef,
    AwsEcsClusterConfigurationDetailsTypeDef,
    AwsEcsServiceDetailsOutputTypeDef,
    AwsEcsServiceDetailsTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsDetailsOutputTypeDef,
    AwsEcsTaskDefinitionContainerDefinitionsDetailsTypeDef,
    AwsEcsTaskDefinitionVolumesDetailsOutputTypeDef,
    AwsEcsTaskDefinitionVolumesDetailsTypeDef,
    AwsEcsTaskDetailsOutputTypeDef,
    AwsEcsTaskDetailsTypeDef,
    AwsEfsAccessPointDetailsOutputTypeDef,
    AwsEfsAccessPointDetailsTypeDef,
    AwsEksClusterDetailsOutputTypeDef,
    AwsEksClusterDetailsTypeDef,
    AwsElasticsearchDomainDetailsOutputTypeDef,
    AwsElasticsearchDomainDetailsTypeDef,
    AwsElbLoadBalancerDetailsOutputTypeDef,
    AwsElbLoadBalancerDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesMalwareProtectionDetailsTypeDef,
    AwsIamAccessKeyDetailsTypeDef,
    AwsIamRoleDetailsOutputTypeDef,
    AwsIamRoleDetailsTypeDef,
    AwsLambdaFunctionDetailsOutputTypeDef,
    AwsLambdaFunctionDetailsTypeDef,
    AwsOpenSearchServiceDomainDetailsOutputTypeDef,
    AwsOpenSearchServiceDomainDetailsTypeDef,
    AwsRdsDbSubnetGroupOutputTypeDef,
    AwsRdsDbSubnetGroupTypeDef,
    AwsRedshiftClusterDetailsOutputTypeDef,
    AwsRedshiftClusterDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterPredicateDetailsOutputTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterPredicateDetailsTypeDef,
    AwsS3BucketNotificationConfigurationFilterOutputTypeDef,
    AwsS3BucketNotificationConfigurationFilterTypeDef,
    AwsS3BucketObjectLockConfigurationTypeDef,
    AwsS3BucketServerSideEncryptionConfigurationOutputTypeDef,
    AwsS3BucketServerSideEncryptionConfigurationTypeDef,
    AwsS3BucketWebsiteConfigurationOutputTypeDef,
    AwsS3BucketWebsiteConfigurationTypeDef,
    BatchUpdateFindingsResponseTypeDef,
    AwsSsmPatchComplianceDetailsTypeDef,
    AwsStepFunctionStateMachineLoggingConfigurationDetailsOutputTypeDef,
    AwsStepFunctionStateMachineLoggingConfigurationDetailsTypeDef,
    AwsWafRegionalRuleGroupDetailsOutputTypeDef,
    AwsWafRegionalRuleGroupDetailsTypeDef,
    AwsWafRegionalWebAclDetailsOutputTypeDef,
    AwsWafRegionalWebAclDetailsTypeDef,
    AwsWafRuleGroupDetailsOutputTypeDef,
    AwsWafRuleGroupDetailsTypeDef,
    AwsWafWebAclDetailsOutputTypeDef,
    AwsWafWebAclDetailsTypeDef,
    AwsWafv2ActionAllowDetailsOutputTypeDef,
    AwsWafv2RulesActionCaptchaDetailsOutputTypeDef,
    AwsWafv2RulesActionCountDetailsOutputTypeDef,
    AwsWafv2ActionAllowDetailsTypeDef,
    AwsWafv2RulesActionCaptchaDetailsTypeDef,
    AwsWafv2RulesActionCountDetailsTypeDef,
    AwsWafv2ActionBlockDetailsOutputTypeDef,
    AwsWafv2ActionBlockDetailsTypeDef,
    BatchGetStandardsControlAssociationsResponseTypeDef,
    BatchUpdateStandardsControlAssociationsResponseTypeDef,
    AutomationRulesFindingFiltersOutputTypeDef,
    AutomationRulesFindingFiltersTypeDef,
    AwsSecurityFindingFiltersOutputTypeDef,
    AwsSecurityFindingFiltersTypeDef,
    GetFindingHistoryResponseTypeDef,
    GetInsightResultsResponseTypeDef,
    NetworkHeaderOutputTypeDef,
    NetworkHeaderTypeDef,
    OccurrencesOutputTypeDef,
    OccurrencesTypeDef,
    RuleGroupSourceStatelessRuleDefinitionOutputTypeDef,
    RuleGroupSourceStatelessRuleDefinitionTypeDef,
    DescribeStandardsResponseTypeDef,
    BatchDisableStandardsResponseTypeDef,
    BatchEnableStandardsResponseTypeDef,
    GetEnabledStandardsResponseTypeDef,
    StatelessCustomActionDefinitionOutputTypeDef,
    StatelessCustomActionDefinitionTypeDef,
    PortProbeActionOutputTypeDef,
    PortProbeActionTypeDef,
    AwsAthenaWorkGroupDetailsTypeDef,
    AwsAutoScalingAutoScalingGroupDetailsOutputTypeDef,
    AwsAutoScalingAutoScalingGroupDetailsTypeDef,
    AwsBackupBackupPlanBackupPlanDetailsOutputTypeDef,
    AwsBackupBackupPlanBackupPlanDetailsTypeDef,
    AwsCertificateManagerCertificateDetailsOutputTypeDef,
    AwsCertificateManagerCertificateDetailsTypeDef,
    AwsCloudFrontDistributionOriginsOutputTypeDef,
    AwsCloudFrontDistributionOriginsTypeDef,
    AwsCloudFrontDistributionOriginGroupsOutputTypeDef,
    AwsCloudFrontDistributionOriginGroupsTypeDef,
    AwsDynamoDbTableDetailsOutputTypeDef,
    AwsDynamoDbTableDetailsTypeDef,
    AwsEc2LaunchTemplateDetailsOutputTypeDef,
    AwsEc2LaunchTemplateDetailsTypeDef,
    AwsEcsClusterDetailsOutputTypeDef,
    AwsEcsClusterDetailsTypeDef,
    AwsEcsTaskDefinitionDetailsOutputTypeDef,
    AwsEcsTaskDefinitionDetailsTypeDef,
    AwsGuardDutyDetectorDataSourcesDetailsTypeDef,
    AwsRdsDbInstanceDetailsOutputTypeDef,
    AwsRdsDbInstanceDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterDetailsOutputTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesFilterDetailsTypeDef,
    AwsS3BucketNotificationConfigurationDetailOutputTypeDef,
    AwsS3BucketNotificationConfigurationDetailTypeDef,
    AwsStepFunctionStateMachineDetailsOutputTypeDef,
    AwsStepFunctionStateMachineDetailsTypeDef,
    AwsWafv2RulesActionDetailsOutputTypeDef,
    AwsWafv2WebAclActionDetailsOutputTypeDef,
    AwsWafv2RulesActionDetailsTypeDef,
    AwsWafv2WebAclActionDetailsTypeDef,
    AutomationRulesConfigTypeDef,
    CreateAutomationRuleRequestRequestTypeDef,
    UpdateAutomationRulesRequestItemTypeDef,
    InsightTypeDef,
    CreateInsightRequestRequestTypeDef,
    GetFindingsRequestGetFindingsPaginateTypeDef,
    GetFindingsRequestRequestTypeDef,
    UpdateFindingsRequestRequestTypeDef,
    UpdateInsightRequestRequestTypeDef,
    NetworkPathComponentOutputTypeDef,
    NetworkPathComponentTypeDef,
    CustomDataIdentifiersDetectionsOutputTypeDef,
    SensitiveDataDetectionsOutputTypeDef,
    CustomDataIdentifiersDetectionsTypeDef,
    SensitiveDataDetectionsTypeDef,
    RuleGroupSourceStatelessRulesDetailsOutputTypeDef,
    RuleGroupSourceStatelessRulesDetailsTypeDef,
    FirewallPolicyStatelessCustomActionsDetailsOutputTypeDef,
    RuleGroupSourceCustomActionsDetailsOutputTypeDef,
    FirewallPolicyStatelessCustomActionsDetailsTypeDef,
    RuleGroupSourceCustomActionsDetailsTypeDef,
    ActionOutputTypeDef,
    ActionTypeDef,
    AwsBackupBackupPlanDetailsOutputTypeDef,
    AwsBackupBackupPlanDetailsTypeDef,
    AwsCloudFrontDistributionDetailsOutputTypeDef,
    AwsCloudFrontDistributionDetailsTypeDef,
    AwsGuardDutyDetectorDetailsOutputTypeDef,
    AwsGuardDutyDetectorDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesDetailsOutputTypeDef,
    AwsS3BucketBucketLifecycleConfigurationRulesDetailsTypeDef,
    AwsS3BucketNotificationConfigurationOutputTypeDef,
    AwsS3BucketNotificationConfigurationTypeDef,
    AwsWafv2RulesDetailsOutputTypeDef,
    AwsWafv2RulesDetailsTypeDef,
    BatchGetAutomationRulesResponseTypeDef,
    BatchUpdateAutomationRulesRequestRequestTypeDef,
    GetInsightsResponseTypeDef,
    CustomDataIdentifiersResultOutputTypeDef,
    SensitiveDataResultOutputTypeDef,
    CustomDataIdentifiersResultTypeDef,
    SensitiveDataResultTypeDef,
    FirewallPolicyDetailsOutputTypeDef,
    RuleGroupSourceStatelessRulesAndCustomActionsDetailsOutputTypeDef,
    FirewallPolicyDetailsTypeDef,
    RuleGroupSourceStatelessRulesAndCustomActionsDetailsTypeDef,
    AwsS3BucketBucketLifecycleConfigurationDetailsOutputTypeDef,
    AwsS3BucketBucketLifecycleConfigurationDetailsTypeDef,
    AwsWafv2RuleGroupDetailsOutputTypeDef,
    AwsWafv2WebAclDetailsOutputTypeDef,
    AwsWafv2RuleGroupDetailsTypeDef,
    AwsWafv2WebAclDetailsTypeDef,
    ClassificationResultOutputTypeDef,
    ClassificationResultTypeDef,
    AwsNetworkFirewallFirewallPolicyDetailsOutputTypeDef,
    RuleGroupSourceOutputTypeDef,
    AwsNetworkFirewallFirewallPolicyDetailsTypeDef,
    RuleGroupSourceTypeDef,
    AwsS3BucketDetailsOutputTypeDef,
    AwsS3BucketDetailsTypeDef,
    DataClassificationDetailsOutputTypeDef,
    DataClassificationDetailsTypeDef,
    RuleGroupDetailsOutputTypeDef,
    RuleGroupDetailsTypeDef,
    AwsNetworkFirewallRuleGroupDetailsOutputTypeDef,
    AwsNetworkFirewallRuleGroupDetailsTypeDef,
    ResourceDetailsOutputTypeDef,
    ResourceDetailsTypeDef,
    ResourceOutputTypeDef,
    ResourceTypeDef,
    AwsSecurityFindingOutputTypeDef,
    AwsSecurityFindingTypeDef,
    GetFindingsResponseTypeDef,
    BatchImportFindingsRequestRequestTypeDef,
)


def get_structure() -> AcceptAdministratorInvitationRequestRequestTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-securityhub` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_securityhub/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
